Subject: bug#46972: RE : RE : RE : RE : bug#46972: 28.0.50; [feature/native-comp] Emacs locks itself during native compilation because of permission denied

From: Matt M <[email-masked]>
Date: Fri, 12 Mar 2021 11:37:22 +0000

If I understand correctly, this is what happens currently :

  1.  Rename oldfile to new temporary name
  2.  Rename newfile to oldfile
  3.  If rename in 2) failed because oldfile has been recreated, go back to 1)
With my change it becomes :

  1.  Delete oldfile
  2.  Rename newfile to oldfile
  3.  If rename in 2) failed because oldfile has been recreated, go back to 1)

The only difference being that oldfile is deleted instead of keeping an .eln.old file.
In the non Windows version of the code no .eln.old file is created anyway.

The problem on Windows is that the oldfile could reappear and block step 2),
so the while loop is necessary, but I keep it in my proposed change.

Or maybe I misunderstood entirely
De : Eli Zaretskii<mailto:[email-masked]>
Envoyé le :vendredi 12 mars 2021 08:36
À : Matt M<mailto:[email-masked]>
Cc : [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Objet :Re: RE : RE : RE : bug#46972: 28.0.50; [feature/native-comp] Emacs locks itself during native compilation because of permission denied

> From: Matt M <[email-masked]>
> CC: "[email-masked]" <[email-masked]>
> Date: Fri, 12 Mar 2021 00:26:18 +0000
>
> The Following patch seems to fix my problem :
> --- a/lisp/emacs-lisp/comp.el
> +++ b/lisp/emacs-lisp/comp.el
> @@ -3778,13 +3778,7 @@ comp-delete-or-replace-file
>           (while
>               (condition-case _
>                   (progn
> -                   ;; oldfile maybe recreated by another Emacs in
> -                   ;; between the following two rename-file calls
> -                   (if (file-exists-p oldfile)
> -                       (rename-file oldfile (make-temp-file-internal
> -                                             (file-name-sans-extension oldfile)
> -                                             nil ".eln.old" nil)
> -                                    t))
> +                   (delete-file oldfile)
>                     (when newfile
>                       (rename-file newfile oldfile nil))
>                     ;; Keep on trying.
> Changed the call to rename-file to delete-file.

Thanks, but I don't think we can use this solution, due to the reason
explained in the comment there.  (You can, of course, use it locally,
if the danger described there is not relevant for your usage.)

I apologize that I didn't yet have time to recreate the problem you
described and look into it: the native-comp branch is still not stable
enough for me to try such non-trivial situations.  I didn't forget,
though.